import { PauseAdGrpcController } from '@modules/ad/interface/grpc-controllers/pause-ad.grpc.controller';
import { CommandBus } from '@nestjs/cqrs';
import { Test, TestingModule } from '@nestjs/testing';

const mockCommandBus = {
  execute: jest.fn(),
};

describe('Pause Ad Grpc Controller', () => {
  let pauseAdGrpcController: PauseAdGrpcController;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      providers: [
        {
          provide: CommandBus,
          useValue: mockCommandBus,
        },
        PauseAdGrpcController,
      ],
    }).compile();

    pauseAdGrpcController = module.get<PauseAdGrpcController>(
      PauseAdGrpcController,
    );
  });

  afterEach(async () => {
    jest.clearAllMocks();
  });

  it('should be defined', () => {
    expect(pauseAdGrpcController).toBeDefined();
  });

  it('should execute the pause ad command', async () => {
    await pauseAdGrpcController.pause({
      id: '200d61a8-d878-4378-a609-c19ea71633d2',
    });
    expect(mockCommandBus.execute).toHaveBeenCalledTimes(1);
  });
});
